## gmic 1.7.9+zart

=== src/Makefile ===
#
#  File        : Makefile
#                ( Makefile for GNU 'make' utility )
#
#  Description : Makefile for compiling :
#
#                 . the G'MIC command line tool (type 'make cli').
#                 . the G'MIC plug-in for GIMP (type 'make gimp').
#                 . the G'MIC interpreter, as a C++ library (type 'make lib').
#                 . the G'MIC C library (type 'make libc' or 'make libcstatic').
#                 . the ZArt software (type 'make zart').
#                 . To compile all of them, just type 'make', or 'make all').
#
#                ( http://gmic.eu )
#
#  Copyright   : David Tschumperle
#                ( http://tschumperle.users.greyc.fr/ )
#
#  License     : CeCILL v2.0
#                ( http://www.cecill.info/licences/Licence_CeCILL_V2-en.html )
#
#  This software is governed by the CeCILL  license under French law and
#  abiding by the rules of distribution of free software.  You can  use,
#  modify and/ or redistribute the software under the terms of the CeCILL
#  license as circulated by CEA, CNRS and INRIA at the following URL
#  "http://www.cecill.info".
#
#  As a counterpart to the access to the source code and  rights to copy,
#  modify and redistribute granted by the license, users are provided only
#  with a limited warranty  and the software's author,  the holder of the
#  economic rights,  and the successive licensors  have only  limited
#  liability.
#
#  In this respect, the user's attention is drawn to the risks associated
#  with loading,  using,  modifying and/or developing or reproducing the
#  software by the user in light of its specific status of free software,
#  that may mean  that it is complicated to manipulate,  and  that  also
#  therefore means  that it is reserved for developers  and  experienced
#  professionals having in-depth computer knowledge. Users are therefore
#  encouraged to load and test the software's suitability as regards their
#  requirements in conditions enabling the security of their systems and/or
#  data to be ensured and,  more generally, to use and operate it in the
#  same conditions as regards security.
#
#  The fact that you are presently reading this means that you have had
#  knowledge of the CeCILL license and that you accept its terms.
#

#---------------------------
# Set OS-specific variables.
#---------------------------

# Try to auto-detect target OS.
OS := $(shell uname)
USR = /usr
LIB = lib
BIN = bin
INCLUDE = include
SO = .so
PIC = -fPIC
EXE =
WGET = wget --no-check-certificate --quiet -O
PLUGINDIR = `gimptool-2.0 --gimpplugindir`/plug-ins

ifeq ($(OS),Linux)
OS = Unix
endif

ifeq ($(OS),GNU/kFreeBSD)
OS = Unix
endif

ifeq ($(OS),GNU)
OS = Unix
endif

ifeq ($(OS),FreeBSD)
OS = Unix
USR = /usr/local
endif

ifeq ($(OS),DragonFly)
OS = Unix
USR = /usr/local
endif

ifeq ($(OS),NetBSD)
OS = Unix
endif

ifneq (, $(findstring MINGW, $(OS)))
OS = Windows
endif

ifeq ($(OS),Darwin)
PLUGINDIR = ~/Library/Application\ Support/Gimp/plug-ins
ifeq (,$(wildcard /opt/local))
USR = /usr/local
else
USR = /opt/local
endif
WGET = curl -k -L --silent -o
endif

ifeq ($(OS),Windows)
EXE = .exe
SO = .dll
PIC =
endif

ifdef NOSTRIP
STRIP = echo skip strip
else
STRIP = strip
endif

#-------------------------------------------------
# Define custom flags for each different features.
#-------------------------------------------------

# Flags set to describe a 'prerelease' version.
NO_PRERELEASE_CFLAGS = -Dgmic_prerelease="\\\"`date +%m%d%y`\\\""

# Minimal set of flags that is mandatory to compile G'MIC.
MANDATORY_CFLAGS = -Dgmic_build -Dcimg_use_zlib `pkg-config --cflags zlib || echo -I$(USR)/$(INCLUDE)` $(PRERELEASE_CFLAGS)
MANDATORY_LIBS = `pkg-config --libs zlib || echo -lz`
ifndef NO_SRIPDLIB
MANDATORY_CFLAGS += -std=c++11 -pedantic
endif
MANDATORY_LIBS += -L$(USR)/$(LIB)
ifeq ($(notdir $(CXX)),g++)
MANDATORY_CFLAGS += -Wall -Wextra -Wfatal-errors
MANDATORY_LIBS += -lm
endif
ifeq ($(OS),Unix)
MANDATORY_CFLAGS += -Dcimg_use_vt100
endif
ifeq ($(OS),Darwin)
ifndef NO_STDLIB
MANDATORY_CFLAGS += -stdlib=libc++
endif
endif
ifeq ($(OS),Windows)
MANDATORY_LIBS += -Wl,--stack,16777216
endif

# Flags to enable software debugging (slow down the code!).
DEBUG_CFLAGS = -pedantic -Dcimg_verbosity=3 -Dcimg_strict_warnings -g -fsanitize=address # -fsanitize=thread # -fsanitize=undefined # Removed '-ansi' as it (silently) disables c++11.

# Flags to enable optimizations.
ifeq ($(notdir $(CXX)),g++)
OPT_CFLAGS = -O3 -mtune=generic # -Ofast -march=native
else
ifeq ($(notdir $(CXX)),icpc)
OPT_CFLAGS = -fast
else
OPT_CFLAGS = -O3
endif
endif

# Flags to enable parallel processing.
PARALLEL_CFLAGS = -Dgmic_is_parallel
ifneq ($(OS),Windows)
PARALLEL_LIBS = -lpthread
endif

# Flags to enable extra checking of image buffer pointers.
ifneq ($(OS),Darwin)
CHECKIMAGE_CFLAGS = # -Dgmic_check_image
endif

# Flags to enable cancellation points in CImg library methods.
# (may slow down the code a little bit).
ABORT_CFLAGS = -Dcimg_use_abort

# Flags to enable parallelization of image processing algorithms, using OpenMP.
OPENMP_CFLAGS = -fopenmp -Dcimg_use_openmp
OPENMP_LIBS = -lgomp

# Flags to enable image display, using X11
# (keep /usr/ dirname here since X11 is located in /usr/ on Mac too).
# This requires the presence of the X11 include and library files.
ifneq ($(OS),Darwin)
X11_CFLAGS = -Dcimg_display=1 -Dcimg_appname=\\\"gmic\\\" `pkg-config --cflags x11 || echo -I/usr/X11R6/include` #-Dcimg_use_xrandr
X11_LIBS = `pkg-config --libs x11 || echo -L/usr/X11R6/lib -lX11` -lpthread #`pkg-config --libs xrandr || echo -lXrandr`
else
ifeq (,$(wildcard /usr/X11R6))
X11_CFLAGS = -Dcimg_display=0 -Dcimg_appname=\\\"gmic\\\" #-Dcimg_use_xrandr
X11_LIBS = -lpthread #`pkg-config --libs xrandr || echo -lXrandr`
else
X11_CFLAGS = -Dcimg_display=1 -Dcimg_appname=\\\"gmic\\\" `pkg-config --cflags x11 || echo -I/usr/X11R6/include` #-Dcimg_use_xrandr
X11_LIBS = -L/usr/X11R6/lib -lX11 -lpthread #`pkg-config --libs xrandr || echo -lXrandr`
endif
endif
# Flags to enable fast display, using XShm.
# This requires the presence of the X11 extension include and library files.
XSHM_CFLAGS = -Dcimg_use_xshm `pkg-config --cflags xcb-shm`
XSHM_LIBS = `pkg-config --libs xcb-shm || echo -L$(USR)/X11R6/lib -lXext`

# Flags to enable image display, using GDI32.
# This requires the presence of the GDI32 include and library files (Windows only).
GDI32_CFLAGS = -Dcimg_display=2 -Dcimg_appname=\\\"gmic\\\"
GDI32_LIBS = -lgdi32

# Flags to enable native support for PNG image files, using the PNG library.
# This requires the presence of the libpng include and library files.
ifneq ($(OS),Darwin)
PNG_CFLAGS = -Dcimg_use_png `pkg-config --cflags libpng`
PNG_LIBS = `pkg-config --libs libpng || echo -lpng -lz`
else
ifeq (,$(wildcard /tmp/skl))
PNG_CFLAGS = -Dcimg_use_png `pkg-config --cflags libpng`
PNG_LIBS = `pkg-config --libs libpng || echo -lpng -lz`
else
PNG_CFLAGS = -Dcimg_use_png
PNG_LIBS = -lpng -lz
endif
endif

# Flags to enable native support for JPEG image files, using the JPEG library.
# This requires the presence of the libjpeg include and library files.
JPEG_CFLAGS = -Dcimg_use_jpeg
JPEG_LIBS = -ljpeg

# Flags to enable native support for TIFF image files, using the TIFF library.
# This requires the presence of the libtiff include and library files.
TIFF_CFLAGS = -Dcimg_use_tiff `pkg-config --cflags libtiff-4`
TIFF_LIBS = `pkg-config --libs libtiff-4 || echo -ltiff`

# Flags to enable native support for MINC2 image files, using the MINC2 library.
# ( http://en.wikibooks.org/wiki/MINC/Reference/MINC2.0_Users_Guide )
MINC2_CFLAGS = -Dcimg_use_minc2 -I${HOME}/local/include
MINC2_LIBS = -lminc_io -lvolume_io2 -lminc2 -lnetcdf -lhdf5 -lz -L${HOME}/local/lib

# Flags to enable native support for downloading files from the network.
# ( http://curl.haxx.se/libcurl/ )
CURL_CFLAGS = -Dcimg_use_curl `pkg-config --cflags libcurl`
CURL_LIBS = `pkg-config --libs libcurl || echo -lcurl`

# Flags to enable native support of webcams and video streaming, using the OpenCV library.
# This requires the presence of the OpenCV include and library files.
OPENCV_CFLAGS = -Dcimg_use_opencv  `pkg-config opencv --cflags || echo -I/usr/include/opencv` -I/usr/include/opencv
OPENCV_LIBS = `pkg-config opencv --libs || echo -lopencv_core -lopencv_highgui`

# Flags to enable native support of most classical image file formats, using the GraphicsMagick++ library.
# This requires the presence of the GraphicsMagick++ include and library files.
MAGICK_CFLAGS = -Dcimg_use_magick `pkg-config --cflags GraphicsMagick++ || echo -I$(USR)/$(INCLUDE)/GraphicsMagick`
MAGICK_LIBS = `pkg-config --libs GraphicsMagick++ || echo -lGraphicsMagick++`

# Flags to enable native support of EXR file format, using the OpenEXR library/
# This requires the presence of the OpenEXR include and library files.
OPENEXR_CFLAGS = -Dcimg_use_openexr -I$(USR)/$(INCLUDE)/OpenEXR
OPENEXR_LIBS = -lIlmImf -lHalf

# Flags to enable the use of the FFTW3 library.
# This requires the presence of the FFTW3 include and library files.
FFTW_CFLAGS = -Dcimg_use_fftw3 `pkg-config --cflags fftw3`
FFTW_LIBS = `pkg-config --libs fftw3 || echo -lfftw3`
ifneq ($(OS),Windows)
FFTW_LIBS += -lfftw3_threads
endif

# Flags to enable the use of the BOARD library.
# This requires the presence of the BOARD include and library files.
BOARD_CFLAGS = -Dcimg_use_board
BOARD_LIBS = -lboard

#---------------------------------------------------------
# Predefine sets of flags to build default configurations.
#---------------------------------------------------------

# CLI interface: Standard build.
#-------------------------------
GMIC_CLI_CFLAGS = $(MANDATORY_CFLAGS) $(ABORT_CFLAGS) $(PARALLEL_CFLAGS) $(FFTW_CFLAGS) $(CURL_CFLAGS) $(PNG_CFLAGS) $(JPEG_CFLAGS) $(TIFF_CFLAGS)
GMIC_CLI_LIBS = $(MANDATORY_LIBS) $(PARALLEL_LIBS) $(FFTW_LIBS) $(CURL_LIBS) $(PNG_LIBS) $(JPEG_LIBS) $(TIFF_LIBS)
ifeq ($(OS),Unix) # Unix.
GMIC_CLI_CFLAGS += $(OPENMP_CFLAGS) $(X11_CFLAGS) $(OPENEXR_CFLAGS) $(OPENCV_CFLAGS) # $(XSHM_CFLAGS) $(MAGICK_CFLAGS)
GMIC_CLI_LIBS += $(OPENMP_LIBS) $(X11_LIBS) $(OPENEXR_LIBS) $(OPENCV_LIBS) # $(XSHM_LIBS) # $(MAGICK_LIBS)
else
ifeq ($(OS),Darwin) # MacOSX.
GMIC_CLI_CFLAGS += $(X11_CFLAGS) $(OPENEXR_CFLAGS)
GMIC_CLI_LIBS += $(X11_LIBS) $(OPENEXR_LIBS) $(OPT_LIBS)
else # Windows.
GMIC_CLI_CFLAGS += $(OPENMP_CFLAGS) $(GDI32_CFLAGS) $(OPENCV_CFLAGS)
GMIC_CLI_LIBS += $(OPENMP_LIBS) $(GDI32_LIBS) $(OPENCV_LIBS)
endif
endif

# CLI interface: Static build.
#-----------------------------
GMIC_STATIC_CLI_PATH = $(USR)/${LIB}/x86_64-linux-gnu
GMIC_STATIC_CLI_EXTRA =
GMIC_STATIC_CLI_CFLAGS = $(MANDATORY_CFLAGS) $(ABORT_CFLAGS) $(PARALLEL_CFLAGS) $(ZLIB_CFLAGS) $(FFTW_CFLAGS) $(PNG_CFLAGS) $(JPEG_CFLAGS) -Dcimg_display=0
GMIC_STATIC_CLI_LIBS = $(PARALLEL_LIBS) \
	               $(GMIC_STATIC_CLI_PATH)/libpng.a \
	               $(GMIC_STATIC_CLI_PATH)/libjpeg.a \
                       $(GMIC_STATIC_CLI_PATH)/libz.a \
                       $(GMIC_STATIC_CLI_PATH)/libfftw3.a $(GMIC_STATIC_CLI_PATH)/libfftw3_threads.a \
	               $(GMIC_STATIC_CLI_EXTRA)

# GIMP plug-in interface: Standard build.
#----------------------------------------
GMIC_GIMP_CFLAGS = $(MANDATORY_CFLAGS) $(ABORT_CFLAGS) $(PARALLEL_CFLAGS) $(FFTW_CFLAGS) $(CURL_CFLAGS) $(PNG_CFLAGS) -Dcimg_use_rng
GMIC_GIMP_LIBS = $(MANDATORY_LIBS) $(PARALLEL_LIBS) $(FFTW_LIBS) $(CURL_LIBS) $(PNG_LIBS)
ifeq ($(OS),Unix) # Unix.
GMIC_GIMP_CFLAGS += $(OPENMP_CFLAGS) $(X11_CFLAGS)
GMIC_GIMP_LIBS += $(OPENMP_LIBS) $(X11_LIBS)
else
ifeq ($(OS),Darwin) # MaxOSX.
GMIC_GIMP_CFLAGS += $(X11_CFLAGS)
GMIC_GIMP_LIBS += $(X11_LIBS)
else # Windows.
GMIC_GIMP_CFLAGS += $(OPENMP_CFLAGS) $(GDI32_CFLAGS)
GMIC_GIMP_LIBS += -mwindows $(OPENMP_LIBS) $(GDI32_LIBS) -lpthread -DPSAPI_VERSION=1 -lpsapi
endif
endif

# Libgmic interface: Standard build.
#-----------------------------------

=== debian/changelog ===
gmic (1.7.9+zart-4build3) bionic; urgency=medium

  * No-change rebuild against libcurl4

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 28 Feb 2018 06:53:55 +0000

gmic (1.7.9+zart-4build2) bionic; urgency=medium

  * No-change rebuild against OpenCV 3.2.

 -- Mattia Rizzolo <mapreri@ubuntu.com>  Sun, 29 Oct 2017 12:48:40 +0100

gmic (1.7.9+zart-4build1) artful; urgency=medium

  * No-change rebuild against OpenCV 3.1.

 -- Mattia Rizzolo <mapreri@ubuntu.com>  Tue, 20 Jun 2017 14:04:32 +0200

gmic (1.7.9+zart-4) unstable; urgency=medium

  * [3dc818a] rise minimal memory, use -O0 on mips.

 -- Bernd Zeimetz <bzed@debian.org>  Fri, 16 Dec 2016 21:00:17 +0100

gmic (1.7.9+zart-3) unstable; urgency=medium

  * [86a3cfa] Ensure we disable optimization on slow arches
    - and on those with small amounts of memory.

 -- Bernd Zeimetz <bzed@debian.org>  Fri, 16 Dec 2016 01:05:06 +0100

gmic (1.7.9+zart-2) unstable; urgency=medium

  * [c754567] Build-depend on bash-completion.
    Quick fix for FTBFS where /etc/bash_completion.d only exists on a few
    buildds.
    Thanks to Adrian Bunk (Closes: #848185)

 -- Bernd Zeimetz <bzed@debian.org>  Thu, 15 Dec 2016 00:51:47 +0100

gmic (1.7.9+zart-1) unstable; urgency=medium

  * [38a82aa] Fix build options
  * [2ccfb41] Merge tag 'upstream/1.7.9'
    Upstream version 1.7.9
  * [dbfb447] Refreshing patches
  * [b2ffc73] Support opencv 3.1.
    Thanks to Nobuhiro Iwamatsu (Closes: #841246)
  * [5d940c9] Updating changelog
  * [513bdc7] Merge tag 'upstream/1.7.9+zart'
    Upstream version 1.7.9+zart
  * [4027a04] Add patch to fix gmic location in zart.pro

 -- Bernd Zeimetz <bzed@debian.org>  Sat, 03 Dec 2016 17:50:28 +0100

=== debian/control ===
Source: gmic
Section: graphics
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Bernd Zeimetz <bzed@debian.org>
Build-Depends: debhelper (>= 8.1.3),
 dpkg-dev (>= 1.16.0),
 dh-exec (>=0.3),
 libgimp2.0-dev (>= 2.4),
 libx11-dev, libxrandr-dev, libfftw3-dev | fftw3-dev,
 libopencv-dev,
 libopenexr-dev,
 libqt4-dev,
 libilmbase-dev,
 libcurl4-openssl-dev,
 bash-completion
Standards-Version: 3.9.4
Homepage: http://gmic.sourceforge.net/
Vcs-Git: git://anonscm.debian.org/collab-maint/gmic.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/gmic.git

Package: gmic
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: gimp-gmic, gmic-zart
Multi-Arch: foreign
Description: GREYC's Magic for Image Computing
 G'MIC is an open and full-featured framework for image processing,
 providing several different user interfaces to
 convert/manipulate/filter/visualize generic image datasets, from 1d
 scalar signals to 3d+t sequences of multi-spectral volumetric images.
 .
 This package contains the stand-alone gmic binary.

Package: gmic-zart
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: gmic
Replaces: gmic (<< 1.5.1.6+dfsg-3~)
Breaks: gmic (<< 1.5.1.6+dfsg-3~)
Multi-Arch: foreign
Description: GREYC's Magic for Image Computing - ZArt
 G'MIC is an open and full-featured framework for image processing,
 providing several different user interfaces to
 convert/manipulate/filter/visualize generic image datasets, from 1d
 scalar signals to 3d+t sequences of multi-spectral volumetric images.
 .
 This package contains ZArt, a program whose purpose is to demonstrate
 the possibilities of the G'MIC image processing language by offering
 the choice of several manipulations on a video stream acquired from a
 webcam. In other words, ZArt is a GUI for G'MIC real-time manipulations
 on the output of a webcam.

Package: gimp-gmic
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, gimp (>= 2.6)
Suggests: gmic
Enhances: gimp
Multi-Arch: foreign
Description: GREYC's Magic for Image Computing - GIMP Plugin
 G'MIC is an open and full-featured framework for image processing,
 providing several different user interfaces to
 convert/manipulate/filter/visualize generic image datasets, from 1d
 scalar signals to 3d+t sequences of multi-spectral volumetric images.
 .
 This package contains the GIMP plugin.

Package: libgmic1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Section: libs
Description: GREYC's Magic for Image Computing - shared library
 G'MIC is an open and full-featured framework for image processing,
 providing several different user interfaces to
 convert/manipulate/filter/visualize generic image datasets, from 1d
 scalar signals to 3d+t sequences of multi-spectral volumetric images.
 .
 This package contains the shared library.

Package: libgmic-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, libgmic1 (= ${binary:Version})
Description: GREYC's Magic for Image Computing - development files
 G'MIC is an open and full-featured framework for image processing,
 providing several different user interfaces to
 convert/manipulate/filter/visualize generic image datasets, from 1d
 scalar signals to 3d+t sequences of multi-spectral volumetric images.
 .
 This package contains the development files for libgmic.

=== debian/rules ===
#!/usr/bin/make -f

BUILDD_MEM := $(shell awk '/^MemTotal:/ {print $$2}' /proc/meminfo)
BUILDD_MEM_OK := $(strip $(shell test $(BUILDD_MEM) -gt 2500000 && echo yes))

BUILDD_SLOW_ARCH := $(strip $(shell dpkg-architecture -qDEB_BUILD_ARCH_CPU | \
  									grep -q -E '^(arm|mips|sh4|m68k|powerpc).*' && echo yes))
BUILDD_MIPS_ARCH := $(strip $(shell dpkg-architecture -qDEB_BUILD_ARCH_CPU | \
									grep -q 'mips' && echo yes))

# powerpc moved to slow arch due to weird build failures

export DEB_BUILD_MAINT_OPTIONS = noopt
ifneq (yes,$(BUILDD_MEM_OK))
  OPT_CFLAGS = -O0
else
  ifneq (yes,$(BUILDD_SLOW_ARCH))
    OPT_CFLAGS = -O3
  else
    ifneq (yes,$(BUILDD_MIPS_ARCH))
       OPT_CFLAGS = -O1 -fno-tree-pre
	else
       OPT_CFLAGS = -O0
    endif
  endif
endif

export DEB_CFLAGS = $(shell dpkg-buildflags --get CFLAGS | sed 's,-O[0-9],,')
export DEB_CXXFLAGS = $(shell dpkg-buildflags --get CXXFLAGS | sed 's,-O[0-9],,')

GMICLDFLAGS= -Wl,-z,relro

%:
	dh $@ --sourcedirectory=src

clean:
	if [ -f zart/Makefile_old ]; then mv zart/Makefile_old zart/Makefile; fi
	if [ -f zart/zart.pro.old ]; then mv zart/zart.pro.old zart/zart.pro; fi
	rm -f src/gmic_use_lib
	dh $@ --sourcedirectory=src

override_dh_auto_configure:
	if [ -f Makefile ]; then cp zart/Makefile zart/Makefile_old; fi
	cp zart/zart.pro zart/zart.pro.old
	echo -e 'QMAKE_CXXFLAGS_RELEASE -= -O1\nQMAKE_CXXFLAGS_RELEASE -= -O2\nQMAKE_CXXFLAGS_RELEASE *= $(OPT_CFLAGS)' >> zart/zart.pro
	dh_auto_configure

override_dh_auto_test: 
	# no tests please.

override_dh_compress:
	dh_compress -X.shtml -X.rss -X.js -X.ppm

override_dh_auto_build:
	export NOSTRIP=1 ;\
	    export MANDATORY_LDFLAGS="-Wl,--as-needed $(GMIC_LDFLAGS)" ;\
	    export OPT_CFLAGS="$(OPT_CFLAGS)" ;\
		export CFLAGS="$(DEB_CFLAGS) $(OPT_CFLAGS)" ;\
		export CXXFLAGS="$(DEB_CXXFLAGS) $(OPT_CFLAGS)" ;\
		export MANDATORY_CFLAGS="$(GMIC_CFLAGS) -I. -I/usr/include/libavcodec/ -I/usr/include/libavformat/ -I/usr/include/libswscale/" ;\
		dh_auto_build --sourcedirectory=src


override_dh_install:
	chmod 755 debian/libgmic*.install
	dh_install --fail-missing
	# FIX CImg.h file name to avoid problems with cimg-dev
	sed -i 's,CImg.h,gmic_CImg.h,g' debian/libgmic-dev/usr/include/gmic.h
	mv debian/libgmic-dev/usr/include/CImg.h debian/libgmic-dev/usr/include/gmic_CImg.h

.PHONY: override_dh_auto_test override_dh_compress override_dh_auto_build override_dh_install

# vim:ts=4 sw=2 noet

## gmic 2.0.0~pre20170120

=== src/Makefile ===
--- 
+++ 
@@ -61,6 +61,8 @@
 EXE =
 WGET = wget --no-check-certificate --quiet -O
 PLUGINDIR = `gimptool-2.0 --gimpplugindir`/plug-ins
+VERSION = `grep 'gmic_version\ ' gmic.h | tail -c4 | head -c3`
+VERSION1 = `grep 'gmic_version\ ' gmic.h | tail -c4 | head -c1`
 
 ifeq ($(OS),Linux)
 OS = Unix
@@ -119,7 +121,7 @@
 #-------------------------------------------------
 
 # Flags set to describe a 'prerelease' version.
-NO_PRERELEASE_CFLAGS = -Dgmic_prerelease="\\\"`date +%m%d%y`\\\""
+PRERELEASE_CFLAGS = -Dgmic_prerelease="\\\"`date +%m%d%y`\\\""
 
 # Minimal set of flags that is mandatory to compile G'MIC.
 MANDATORY_CFLAGS = -Dgmic_build -Dcimg_use_zlib `pkg-config --cflags zlib || echo -I$(USR)/$(INCLUDE)` $(PRERELEASE_CFLAGS)
@@ -288,7 +290,7 @@
 
 # CLI interface: Static build.
 #-----------------------------
-GMIC_STATIC_CLI_PATH = $(USR)/${LIB}/x86_64-linux-gnu
+GMIC_STATIC_CLI_PATH = $(USR)/$(LIB)/x86_64-linux-gnu
 GMIC_STATIC_CLI_EXTRA =
 GMIC_STATIC_CLI_CFLAGS = $(MANDATORY_CFLAGS) $(ABORT_CFLAGS) $(PARALLEL_CFLAGS) $(ZLIB_CFLAGS) $(FFTW_CFLAGS) $(PNG_CFLAGS) $(JPEG_CFLAGS) -Dcimg_display=0
 GMIC_STATIC_CLI_LIBS = $(PARALLEL_LIBS) \
@@ -316,4 +318,3 @@
 endif
 
 # Libgmic interface: Standard build.
-#-----------------------------------

=== debian/changelog ===
gmic (1:2.0.0~pre20170120-0bpo8.obs) jessie; urgency=medium

  * Rebuild for Debian 8 (Jessie).

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 17 Mar 2017 15:56:58 -0700

gmic (1:2.0.0~pre20170120-0t2~ppa~edge) trusty; urgency=high
  
  * Prerelease: https://discuss.pixls.us/t/on-the-road-to-gmic-2-0-0/2758

 -- Otto Meier <otto@kesselgulasch.org>  Tue, 31 Jan 2016 22:59:00 +0100

gmic (1:1.8.0~pre-0y1~ppa~edge) yaketty; urgency=high
  
  * Prerelease: https://discuss.pixls.us/t/on-the-road-to-gmic-1-8-0/2758
  * Rebuild

 -- Otto Meier <otto@kesselgulasch.org>  Wed, 18 Jan 2016 21:15:00 +0100

gmic (1:1.7.9-0z0~ppa) zesty; urgency=high
  
  * New release: https://discuss.pixls.us/t/release-of-gmic-1-7-9/2497

 -- Otto Meier <otto@kesselgulasch.org>  Fri, 18 Nov 2016 20:15:00 +0100

gmic (1:1.7.3-0t2~ppa~edge) trusty; urgency=high
  
  * Upstream release

 -- Otto Meier <otto@kesselgulasch.org>  Sun, 03 Jul 2016 23:25:00 +0200

gmic (1:1.7.2-0p0~ppa) precise; urgency=high
  
  * Changelog: https://discuss.pixls.us/t/release-of-gmic-1-7-2/1348

 -- Otto Meier <otto@kesselgulasch.org>  Mon, 30 May 2016 22:38:00 +0200

gmic (1:1.6.5.9.100-0w1~ppa~edge) wily; urgency=high
  
  * Beta release
  * Try gcc-5 for wily
  * Changelog: https://discuss.pixls.us/t/on-the-road-to-gmic-1-6-6-0/383

 -- Otto Meier <otto@kesselgulasch.org>  Wed, 23 Sep 2015 01:40:34 +0200

gmic (1.5.7.1-0precise3~ppa) precise; urgency=high

  * Upstream Release
  * New features:
    - New substituting expression '@*' that returns the number of available cpus.
    - New choice "Auto" for parallel processing options in GIMP plug-in filters. 
    - Improved commands '-apply_parallel' and '-apply_parallel_overlap' for parallelization of algorithms.

  * Optimizations / Changes:
    - Command '-fft' now uses parallel computation to speed up the execution.
    - First command (and only the first) specified as an argument of '-parallel' is now able to modify global variables. 

 -- Otto Meier <otto@kesselgulasch.org>  Thu, 17 Sep 2013 16:51:34 +0200

gmic (1.5.7.0-0saucy1~ppa) saucy; urgency=high

  * Upstream Release

 -- Otto Meier <otto@kesselgulasch.org>  Tue, 10 Sep 2013 17:11:34 +0200

gmic (1.5.6.1-0precise0~ppa) precise; urgency=high
  
  * Upstream Beta Release
  * And here it is, another cool new version of the G'MIC framework :) Enjoy, and see you after the summer holidays :)
  
  * New features:
    - New filter 'Lights & Shadows / Drop shadow 3d' to create shadows layers projected on 3d planes
    - New filter 'Colors / Colorize comics' designed to help colorizing B&W sketches
    - New command '-pack_sprites', allows to do 'generic' shape fitting, i.e. render clouds of non-intersecting shapes with opt. masking. 
      Two new filters in the GIMP plug-in are using this generic command : 'Artistic / Shapeism' and 'Patterns / Pack sprites'
    - New command '-rprogress' to set a progress bar relatively to user-defined bounds. This allows progress bar to be coherent even when set by calls of sub-commands.
    
    Modifications:
    
    - Removed native commands '-haar' and '-ihaar' and recoded them as custom commands, with same parameters.
    - Re-organized the sections of the filters tree in the GIMP plug-in.
    - Zooming on a particular slice of a volumetric image in the embedded viewer now keeps displaying the z-coordinates of the explored voxels.
    
    Bug fixes:
    
    - Fixed : saving raw files in 'unsigned int' type mode were actually saving files in unsigned short instead [reponrted by Zonderr].
    - Fixed bug in command '-polygon' where list of vertices contained double points and opacity was <1.
    - Fixed : GIMP plug-in running in non-interactive mode now force output to be in-place. Was depending on the last selection (done in interactive mode).
    - Fixed : when running GIMP plug-in in non-interactive mode, progress bar works as expected.
     
 -- Otto Meier <otto@kesselgulasch.org>  Thu, 04 Jul 2013 09:54:34 +0200

gmic (1.5.5.2-0quantal2~ppa) quantal; urgency=high
  
  * Upstream Relase
  * This is a minor bugfixes release. Nothing outstanding, but better than previous version anyway :) Enjoy !
  
  * New features :
  
    - New filter 'Patterns / Seamless turbulence', which creates seamless turbulence patterns.
    - New command '-spline3d' to generate 3d cubic spline curves.
  * Improvements / Changes :
  
    - Slightly optimized blending step in patch-based inpainting algorithm.
    - Command '-spline' is now a custom command, instead of a native one.
    - Update mechanism for GIMP plug-in has been slightly changed. Only one update file is now required for all external contributions, which speeds up the update procedure dramatically.
    - Command '-output' better manages the saving of 'empty' images, by creating 0-bytes files in case the requested format does not support the storage of empty images (most of the formats actually).
    - Plug-in filters are now ordered in alphabetical order inside folders.
  
  * Bug fixes :
  
    - Loading single frame GIF files did not support alpha-channels. This has been fixed.
    -  Fixed bug happening when first displaying an image list with command '-window', modify its value range, then displaying it using command '-display'. Very rare bug to be honest!
    - Substituted expression @{ind,t} does not end a command line anymore, if image [ind] contains a 0.
    - Bugfix in '-object3d' : objects having sprites primitives with single colors and transparency masks were displayed at the wrong location. Thanks Jerome Boulanger for having noticed this! 
  
 -- Otto Meier <otto@kesselgulasch.org>  Fri, 19 Apr 2013 18:24:34 +0100
 

gmic (1.5.5.1-0quantal2~ppa) quantal; urgency=high
  
  * Upstream release
    
  * New features:
  
  * New command '-patches' can extract several patches from selected images, in a very quick way.
  * New command '-repair' to perform patch-based inpainting with an extra original blending algorithm. Very useful command!  


=== debian/control ===
Source: gmic
Section: graphics
Priority: optional
Maintainer: Otto Meier <otto@kesselgulasch.org>
XBSC-Original-Maintainer: Bernd Zeimetz <bzed@debian.org>
Build-Depends: debhelper (>= 7.0.50),
 libgimp2.0-dev (>= 2.4),
 libjpeg-dev,
 libcv-dev,
 libopencv-dev,
 libhighgui-dev,
 libavcodec-dev,
 libavformat-dev, 
 libswscale-dev,
 libx11-dev, 
 libxrandr-dev, 
 libfftw3-dev | fftw3-dev,
 libopencv-highgui-dev, 
 libopencv-objdetect-dev, 
 libopencv-legacy-dev,
 libopencv-ml-dev, 
 libopencv-video-dev, 
 libopencv-contrib-dev,
 libopencv-imgproc-dev, 
 libopenexr-dev, 
 qt5-default | qt4-default,
 libgomp1,
 libjson-glib-dev,
 libgegl-0.0-dev | libgegl-dev,
 libcurl4-openssl-dev,
 bc,
 wget,
 libtiff5-dev | libtiff4-dev
Standards-Version: 3.9.6
Homepage: http://gmic.sourceforge.net/
Vcs-Git: git://git.debian.org/collab-maint/gmic.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/gmic.git

Package: gmic
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: gimp-gmic, gmic-zart
Description: GREYC's Magic Image Converter
 G'MIC is an interpreter of image processing macros whose goal is to
 convert, manipulate and visualize generic 1D/2D/3D multi-spectral
 image files. This includes classical color images, but also more
 complex data as image sequences or 3D volumetric images.
 .
 This package contains the stand-alone gmic binary.

Package: gmic-zart
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: gmic
Replaces: gmic (<< 1.5.1.6+dfsg-3~)
Breaks: gmic (<< 1.5.1.6+dfsg-3~)
Description: GREYC's Magic Image Converter - ZArt
 G'MIC is an interpreter of image processing macros whose goal is to
 convert, manipulate and visualize generic 1D/2D/3D multi-spectral
 image files. This includes classical color images, but also more
 complex data as image sequences or 3D volumetric images.
 .
 This package contains ZArt, a program whose purpose is to demonstrate
 the possibilities of the G'MIC image processing language by offering
 the choice of several manipulations on a video stream acquired from a
 webcam. In other words, ZArt is a GUI for G'MIC real-time manipulations
 on the output of a webcam.

Package: gimp-gmic
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, gimp (>= 2.6)
Suggests: gmic
Enhances: gimp
Description: GIMP plugin for GREYC's Magic Image Converter
 G'MIC is an interpreter of image processing macros whose goal is to
 convert, manipulate and visualize generic 1D/2D/3D multi-spectral
 image files. This includes classical color images, but also more
 complex data as image sequences or 3D volumetric images.
 .
 This package contains the GIMP plugin.

Package: libgmic1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Section: libs
Description: GREYC's Magic for Image Computing - shared library
 G'MIC is an open and full-featured framework for image processing,
 providing several different user interfaces to
 convert/manipulate/filter/visualize generic image datasets, from 1d
 scalar signals to 3d+t sequences of multi-spectral volumetric images.
 .
 This package contains the shared library.

Package: libgmic-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, libgmic1 (= ${binary:Version})
Description: GREYC's Magic for Image Computing - development files
 G'MIC is an open and full-featured framework for image processing,
 providing several different user interfaces to
 convert/manipulate/filter/visualize generic image datasets, from 1d
 scalar signals to 3d+t sequences of multi-spectral volumetric images.
 .
 This package contains the development files for libgmic.

=== debian/rules ===
#!/usr/bin/make -f

BUILDD_MEM := $(shell awk '/^MemTotal:/ {print $$2}' /proc/meminfo)
BUILDD_MEM_OK := $(strip $(shell test $(BUILDD_MEM) -gt 1800000 && echo yes))
#GMIC_FLAGS := "-pipe -march=bdver1 -mno-movbe -mno-fma -mno-bmi -mno-tbm --param l1-cache-size=16 --param l1-cache-line-size=64 --param l2-cache-size=2048 -mtune=bdver1"

#export CC=/usr/bin/gcc-4.8

%:
	dh $@ --sourcedirectory=src

clean:
	if [ -f zart/Makefile_old ]; then mv zart/Makefile_old zart/Makefile; fi
	rm -f zart/Makefile
	rm -f zart/zart
	rm -f zart/qrc_zart.cpp
	rm -rf zart/.ui zart/.obj zart/.moc
	rm -f src/gmic_use_lib
	dh $@ --sourcedirectory=src

override_dh_auto_configure:
	#cp zart/Makefile zart/Makefile_old
	dh_auto_configure

override_dh_auto_test: 
	# no tests please.

override_dh_compress:
	dh_compress -X.shtml -X.rss -X.js -X.ppm

override_dh_auto_build:
	dh_auto_build -- \
		LDFLAGS="-Wl,--as-needed" \
		CFLAGS="$(GMIC_CFLAGS)  -I. -I/usr/include/libavcodec/ -I/usr/include/libavformat/ -I/usr/include/libswscale/"

override_dh_install:
	dh_install
	install -d $(CURDIR)/debian/gmic/etc/bash_completion.d
	install -D -m644 resources/gmic_bashcompletion.sh \
	                 $(CURDIR)/debian/gmic/etc/bash_completion.d/gmic


.PHONY: override_dh_auto_test override_dh_compress override_dh_auto_build override_dh_install

# vim:ts=4 sw=2 noet

## gmic 2.0.2

=== src/Makefile ===
--- 
+++ 
@@ -8,7 +8,6 @@
 #                 . the G'MIC plug-in for GIMP (type 'make gimp').
 #                 . the G'MIC interpreter, as a C++ library (type 'make lib').
 #                 . the G'MIC C library (type 'make libc' or 'make libcstatic').
-#                 . the ZArt software (type 'make zart').
 #                 . To compile all of them, just type 'make', or 'make all').
 #
 #                ( http://gmic.eu )
@@ -110,6 +109,18 @@
 PIC =
 endif
 
+ifneq (,$(wildcard ../../gmic/src))
+ZART_GMIC_PATH=../../gmic/src
+else
+ZART_GMIC_PATH=../src
+endif
+
+ifneq (,$(wildcard ../../gmic/src))
+QT_GMIC_PATH=../gmic/src
+else
+QT_GMIC_PATH=../src
+endif
+
 ifdef NOSTRIP
 STRIP = echo skip strip
 else
@@ -121,11 +132,12 @@
 #-------------------------------------------------
 
 # Flags set to describe a 'prerelease' version.
-PRERELEASE_CFLAGS = -Dgmic_prerelease="\\\"`date +%m%d%y`\\\""
+NO_PRERELEASE = `date +%y%m%d`
+NO_PRERELEASE_CFLAGS = -Dgmic_prerelease="\\\"$(PRERELEASE)\\\""
 
 # Minimal set of flags that is mandatory to compile G'MIC.
-MANDATORY_CFLAGS = -Dgmic_build -Dcimg_use_zlib `pkg-config --cflags zlib || echo -I$(USR)/$(INCLUDE)` $(PRERELEASE_CFLAGS)
-MANDATORY_LIBS = `pkg-config --libs zlib || echo -lz`
+MANDATORY_CFLAGS = -Dgmic_build -Dcimg_use_zlib `pkg-config --cflags zlib || echo -I$(USR)/$(INCLUDE)` $(PRERELEASE_CFLAGS) $(EXTRA_CFLAGS)
+MANDATORY_LIBS = `pkg-config --libs zlib || echo -lz` $(EXTRA_LIBS)
 ifndef NO_SRIPDLIB
 MANDATORY_CFLAGS += -std=c++11 -pedantic
 endif
@@ -151,7 +163,7 @@
 
 # Flags to enable optimizations.
 ifeq ($(notdir $(CXX)),g++)
-OPT_CFLAGS = -O3 -mtune=generic # -Ofast -march=native
+OPT_CFLAGS = -O3 -mtune=generic
 else
 ifeq ($(notdir $(CXX)),icpc)
 OPT_CFLAGS = -fast
@@ -300,21 +312,14 @@
                        $(GMIC_STATIC_CLI_PATH)/libfftw3.a $(GMIC_STATIC_CLI_PATH)/libfftw3_threads.a \
 	               $(GMIC_STATIC_CLI_EXTRA)
 
-# GIMP plug-in interface: Standard build.
-#----------------------------------------
-GMIC_GIMP_CFLAGS = $(MANDATORY_CFLAGS) $(ABORT_CFLAGS) $(PARALLEL_CFLAGS) $(FFTW_CFLAGS) $(CURL_CFLAGS) $(PNG_CFLAGS) -Dcimg_use_rng
-GMIC_GIMP_LIBS = $(MANDATORY_LIBS) $(PARALLEL_LIBS) $(FFTW_LIBS) $(CURL_LIBS) $(PNG_LIBS)
+# GIMP GTK plug-in interface: Standard build.
+#--------------------------------------------
+GMIC_GIMP_GTK_CFLAGS = $(MANDATORY_CFLAGS) $(ABORT_CFLAGS) $(PARALLEL_CFLAGS) $(FFTW_CFLAGS) $(CURL_CFLAGS) $(PNG_CFLAGS) -Dcimg_use_rng -DGIMP_DISABLE_DEPRECATED
+GMIC_GIMP_GTK_LIBS = $(MANDATORY_LIBS) $(PARALLEL_LIBS) $(FFTW_LIBS) $(CURL_LIBS) $(PNG_LIBS)
 ifeq ($(OS),Unix) # Unix.
-GMIC_GIMP_CFLAGS += $(OPENMP_CFLAGS) $(X11_CFLAGS)
-GMIC_GIMP_LIBS += $(OPENMP_LIBS) $(X11_LIBS)
+GMIC_GIMP_GTK_CFLAGS += $(OPENMP_CFLAGS) $(X11_CFLAGS)
+GMIC_GIMP_GTK_LIBS += $(OPENMP_LIBS) $(X11_LIBS)
 else
 ifeq ($(OS),Darwin) # MaxOSX.
-GMIC_GIMP_CFLAGS += $(X11_CFLAGS)
-GMIC_GIMP_LIBS += $(X11_LIBS)
-else # Windows.
-GMIC_GIMP_CFLAGS += $(OPENMP_CFLAGS) $(GDI32_CFLAGS)
-GMIC_GIMP_LIBS += -mwindows $(OPENMP_LIBS) $(GDI32_LIBS) -lpthread -DPSAPI_VERSION=1 -lpsapi
-endif
-endif
-
-# Libgmic interface: Standard build.
+GMIC_GIMP_GTK_CFLAGS += $(X11_CFLAGS)
+GMIC_GIMP_GTK_LIBS += $(X11_LIBS)
